using Syncfusion.Windows.Forms.Grid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace WindowsApplication2 {
    public partial class Form1 : Form {
        public Form1() {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e) {
            gridControl1.WantTabKey = true;
            gridControl1.WantEnterKey = true;
            gridControl1.Model.Options.WrapCellBehavior = GridWrapCellBehavior.WrapRow;
            
            gridControl1.CurrentCellKeyDown += new KeyEventHandler(gridControl1_CurrentCellKeyDown);
            gridControl1.CurrentCellKeyUp += new KeyEventHandler(gridControl1_CurrentCellKeyUp);
        }

        int LastColIndex = -1;
        void gridControl1_CurrentCellKeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Enter)
            {
                GridControl grid = sender as GridControl;
                GridCurrentCell cc = grid.CurrentCell;
                LastColIndex = cc.ColIndex;
            }
        }

        void gridControl1_CurrentCellKeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Enter)
            {   
                GridControl grid = sender as GridControl;
                GridCurrentCell cc = grid.CurrentCell;
                if( LastColIndex == cc.ColIndex ) 
                {
                    int row = cc.RowIndex, col = cc.ColIndex + 1;
                    if (!grid.Model[row, col].Enabled)
                    {
                        for (int i = row; i <= grid.RowCount; i++)
                        {
                            row = i;
                            cc.QueryNextEnabledCell(GridDirectionType.Right, ref row, ref col);
                            if (grid.Model[row, col].Enabled)
                                break;
                            col = 1;
                        }
                        cc.MoveTo(row, col);
                        cc.ScrollInView();
                    }
                }
            }
        }

       
    }
}